# ifndef FONTSELECT_H
# define FONTSELECT_H

#include <qapplication.h>

#include <qdialog.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qlcdnumber.h>
#include <qslider.h>
#include <qmenubar.h>

#include <qpainter.h>
#include <qpixmap.h>

#include <stdlib.h>

class FontSelect : public QDialog
{
    Q_OBJECT
public:
    FontSelect( QWidget *parent=0, const char *name=0 );
private slots:
    void         newStrikeOut();
    void         doFont();
    void         newUnderline();
    void         newItalic();
    void         newWeight( int id );
    void         newFamily();
    void         newSize( int );
    void         slidingSize( int );
    void         doApply();
    void         familyActivated( int );
    void         pSizeActivated( int );
    void         pKodeActivated( int );
signals:
    void         newFont( const QFont & );
protected:
    void         updateMetrics();
private:
    QLabel       *familyL;
    QLabel       *sizeL;
    QLineEdit    *family;
    QLineEdit    *sizeE;
    QCheckBox    *italic;
    QCheckBox    *underline;
    QCheckBox    *strikeOut;
    QPushButton  *apply;
    QPushButton  *stat;
    QSlider      *sizeS;
    QRadioButton *rb[5];
    QButtonGroup *weight;
    QGroupBox    *mGroup;
    QFont         f;
    QMenuBar     *menu;
    QLabel       *metrics[4][2];
    QWidget      *fontInternal;
};

# endif
