/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
# include <stdlib.h>
# include <stdio.h>
# include "main.h"
# include "slowo.h"
# include "slowo.xpm"
# include "readme.cpp"
//----------------------------------------------------------------

t_WorterBuch  Buch ;
t_Forever    *Forever ;
t_Stande     *Stande ;
t_Stande1     Stande1 ;
QMessageBox  *Message ;
t_Help       *Help ;

long   i_str,i1_str,i_File=0 ;

char   StartPath[300] ;

QPalette  TPalette( char _c );
QColor    TColor( char c );

/***************************************************************************/
t_ListBox :: t_ListBox( QWidget *parent, const char *name )
	   : QListBox( parent, name ) {  ;  }
/* ----------------------------------------------------------------------- */
void t_ListBox :: keyPressEvent( QKeyEvent *E )
{  long n_Line=Forever->WW->n_Line ;

   QListBox :: keyPressEvent( E );
   if( Key_Escape==E->key() )
       Forever->WW->Text->setText("");
   if( Key_Up==E->key() ) i_str-- ;
   if( Key_Down==E->key() ) i_str++ ;
   if( Key_PageUp==E->key() ) i_str-=n_Line ;
   if( Key_PageDown==E->key() ) i_str+=n_Line ;

   if( i_str<0 ) i_str=0 ;
   if( Buch.n_sy_Word<=i_str ) i_str=Buch.n_sy_Word ;
   if( i_str<i1_str ) i1_str=i_str ;
   if( i1_str+n_Line<=i_str ) i1_str=i_str-n_Line+1 ;

   Forever->WW->redraw();
}
/***************************************************************************/
t_LineEdit :: t_LineEdit( QWidget *parent, const char *name )
	    : QLineEdit( parent, name ) { ; }
/* ----------------------------------------------------------------------- */
void t_LineEdit :: keyPressEvent( QKeyEvent *E )
{
   QLineEdit :: keyPressEvent( E );
   if( Key_Escape==E->key() )
       setText("");
   if( Key_Up==E->key() || Key_Down==E->key() ||
       Key_PageUp==E->key() || Key_PageDown==E->key() )
       Forever->WW->List->keyPressEvent( E );
}
/***************************************************************************/
t_Widget :: t_Widget( QWidget *parent, const char *name )
	   : QWidget( parent, name )
{
   List=new t_ListBox( this );
   List->setAutoScrollBar( FALSE );
   connect( List,SIGNAL(selected(int)),this,SLOT(selected1(int)) );

   SB  =new QScrollBar( QScrollBar::Vertical ,this );
   SB->setRange(0,400);
   SB->setValue(200);
   connect( SB,SIGNAL(valueChanged(int)),this,SLOT(sb_change(int)) );

   Text=new t_LineEdit( this );
   connect( Text,SIGNAL(textChanged(const char *)),this,SLOT(text_change(const char *)) );
   connect( Text,SIGNAL(returnPressed( )),Forever,SLOT(antwort()) );
}
/* ----------------------------------------------------------------------- */
void t_Widget :: resizeEvent( QResizeEvent *E )
{  long w,h,h1 ;

   w=E->size().width() ;
   h=E->size().height() ;

   List->setGeometry( 0   ,0   ,w-15 ,h-30 );
   Text->setGeometry( 0   ,h-30,w    ,30   );
   SB  ->setGeometry( w-15,0   ,15   ,h-30 );
   h1 = List->itemHeight( );

   n_Line=(h-30)/h1 ;
   SB  ->setSteps( 1,n_Line );
   redraw( );
}
/* ----------------------------------------------------------------------- */
void t_Widget :: redraw( void )
{  long i ;
   char *Buf ;

   Buch.read_paragraf( i1_str );
   for( i=0 ; i<n_Line ; i++ )
   {
      Buf=Buch.wort( i1_str+i );
      if( List->count()<=i ) List->insertItem( Buf,i );
	  else               List->changeItem( Buf,i );
   }
   List->setSelected( i_str-i1_str,TRUE );
   SB->setRange( 0,Buch.n_sy_Word );
   SB->setValue( i1_str );
}
/* ----------------------------------------------------------------------- */
void t_Widget :: selected1( int i )
{
   Text->setText( List->text(i) );
   Forever->antwort();
}
/* ----------------------------------------------------------------------- */
void t_Widget :: sb_change( int i )
{
   i1_str=i ;
   if( i_str<i1_str         ) i_str=i1_str ;
   if( i1_str+n_Line<=i_str ) i_str=i1_str+n_Line-1 ;
   redraw();
}
/* ----------------------------------------------------------------------- */
void t_Widget :: text_change(const char *text)
{  long i ;

   i=Buch.find( (char *)text );
   if( 0<=i ) i_str=i ;
   if( i_str<i1_str ) i1_str=i_str ;
   if( i1_str+n_Line<=i_str ) i1_str=i_str-n_Line+1 ;

   redraw();
}
/***************************************************************************/
t_Widget2 :: t_Widget2( QWidget *parent, const char *name )
	   : QWidget( parent, name )
{
   Trans=new QLineEdit( this );
   Text1=new QMultiLineEdit( this );
}
/* ----------------------------------------------------------------------- */
void t_Widget2 :: resizeEvent( QResizeEvent *E )
{  long w,h,h1 ;

   w=E->size().width() ;
   h=E->size().height() ;

   Trans->setGeometry( 0,  0 ,w ,30   );
   Text1->setGeometry( 0, 30 ,w ,h-30 );

   //redraw( );
}
/***************************************************************************/
t_Help :: t_Help( QWidget *parent, const char *name )
	: QWidget( parent, name )
{
   Text   = new QMultiLineEdit( this );
   Text->setText( HelpText );
   Button = new QPushButton( "?",this );
   connect( Button,SIGNAL(pressed()),this,SLOT(close1()) );
}
/* ----------------------------------------------------------------------- */
void t_Help :: close1( void )
{   close();  }
/* ----------------------------------------------------------------------- */
void t_Help :: resizeEvent( QResizeEvent *E )
{  long w,h,h1 ;

   w=E->size().width() ;
   h=E->size().height() ;

   Text  ->setGeometry( 0      ,0   ,w   ,h-30 );
   Button->setGeometry( w/2-50 ,h-30,100 ,30 );
}
/***************************************************************************/
t_Forever :: t_Forever( QWidget *parent, const char *name )
	   : QWidget( parent, name )
{
   Stande=NULL ;
   QPixmap Pix1( (const char **)lingvo_xpm );
   setIcon( Pix1 );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: init( void )
{  char  Buf[30] ;
   short i ;

   Menu  = new QMenuBar( this );
   Menu1 = new QPopupMenu( );
 //  Menu2 = new QPopupMenu( );
   Menu3 = new QPopupMenu( );
   for( i=0 ; i<n_Files ; i++ )
	Menu1->insertItem( Files[i] );
   Menu1->insertItem( "Exit" );
   connect( Menu1,SIGNAL(activated(int)),this,SLOT(my_slowar(int)) );

//   Menu2->insertItem( "&",this,SLOT(font()) );
//   Menu2->insertItem( "&",this,SLOT(save_param()) );

   Menu3->insertItem( "& ",this,SLOT(about()) );
   Menu3->insertItem( "& ",this,SLOT(help()) );

   Menu->insertItem( "&"  , Menu1 );
//   Menu->insertItem( "&", Menu2 );
   Menu->insertItem( "&", Menu3 );

   Sp  =new QSplitter( this );
   Sp->setOrientation( QSplitter::Vertical );

   WW  =new t_Widget( Sp );

   WW2 =new t_Widget2( Sp );
   WW->Text->setFocus();
}
/* ----------------------------------------------------------------------- */
void t_Forever :: resizeEvent( QResizeEvent *E )
{
   long w=E->size().width() ;
   long h=E->size().height() ;
   long h1=Menu->geometry().height() ;
   Sp->setGeometry( 0,h1,w ,h-h1 );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: my_slowar( int i )
{  char Name[200] ;

   if( n_Files<=i ) exit(0) ;

   strcpy( Name,StartPath );
   strcat( Name,(char *)Files[i] );

   Buch.make( Name );
   i_str=i1_str=0 ;
   i_File=i ;
   set_param( );

   WW->text_change( WW->Text->text() );
   WW->redraw( );
   antwort( );

   sprintf( Name,"Slowo %s",(char *)Files[i] );
   Name[strlen(Name)-4]=0 ;
   setCaption( Name );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: about( void )
{
   QMessageBox::about( this,"About",
		"  UNIX\n  .. 9  1999" );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: help( void )
{
   Help=new t_Help( );
   Help->show();
}
/* ----------------------------------------------------------------------- */
void t_Forever :: font( void )
{
   if( Stande==NULL )
   Stande = new t_Stande ;
   Stande->show();
}
/* ----------------------------------------------------------------------- */
void t_Forever :: save_param( void )
{
   Stande1.write( );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: antwort( void )
{  long  i_wort ;

   i_wort=i_str ;
   if( i_wort<0 ) return ;
   Buch.read_paragraf( i_wort );

   WW->Text->setText( Buch.wort( i_wort ) );
   WW2->Trans->setText( Buch.trans( i_wort ) );
   WW2->Text1->setText( Buch.answer( i_wort ) );
}
/* ----------------------------------------------------------------------- */
void t_Forever :: set_param( void )
{  t_DictStande *DS=Stande1.Dict+i_File+1 ;
/*
Menu->setPalette( TPalette( DS->Text[0].color ) );
Menu1->setPalette( TPalette( DS->Text[0].color ) );
Menu3->setPalette( TPalette( DS->Text[0].color ) );
*/
{  QFont FF( DS->Text[1].Font );
   FF.setRawMode( TRUE );
   WW->List->setFont( FF );
   WW->List->setPalette( TPalette( 0xf0/*(DS->Text[1].color)&0x0ff*/ ) );
}
{  QFont FF( DS->Text[2].Font );
   FF.setRawMode( TRUE );
   WW->Text->setFont( FF );
   WW->Text->setPalette( TPalette( (DS->Text[2].color)&0x0ff ) );
}
{  QFont FF( DS->Text[3].Font );
   FF.setRawMode( TRUE );
   WW2->Trans->setFont( FF );
   WW2->Trans->setPalette( TPalette( (DS->Text[3].color)&0x0ff ) );
}
{  QFont FF( DS->Text[4].Font );
   FF.setRawMode( TRUE );
   WW2->Text1->setFont( FF );
   WW2->Text1->setPalette( TPalette( (DS->Text[4].color)&0x0ff ) );
}
   Buch.set_divider( DS->Divider ) ;
   Buch.set_sort( DS->SortOrder ) ;
}
/* ----------------------------------------------------------------------- */
QPalette TPalette( char _c )
{
   QColor c ( TColor( _c&0x0f ) );
   QColor c1( TColor( (_c>>4)&0x0f ) );
   QColor c0( TColor( 7 ) );
   //QColorGroup cg( c,c1,c0,c0,c0,c,c1 );
   QColorGroup cg( c,c1,c1,c0,c0,c,c1 );
   return QPalette( cg,cg,cg );
}
/* ----------------------------------------------------------------------- */
void set_path( int argc, char *argv[] )
{  short i ;

   for( i=1 ; i<argc-1 ; i++ )
      if( 0==strcmp(argv[i],"-path") )
      {   strcpy( StartPath,argv[i+1] ) ;
	  if( StartPath[strlen(StartPath)-1]!='/' )
	      strcat( StartPath,"/" );
	  break ;
      }
}
/* ----------------------------------------------------------------------- */
int main( int argc, char **argv )
{   short i ;
    char  r ;
    char Name[200] ;

    r=Stande1.read1( );
    set_path( argc, argv );

    init_buch( StartPath );

    Stande1.init( );
    if( r<0 ) Stande1.write( );
    else  Stande1.read2( );

    i_File=Stande1.i_default_Dict ;
    strcpy( Name,StartPath );
    strcat( Name,(char *)Files[i_File] );

    Buch.make( Name );

    i_str=i1_str=0 ;

    QApplication a( argc, argv );
    t_Forever F ;
    Forever=&F ;
    a.setMainWidget( &F );
    F.init();
    F.set_param();
    F.show();

    sprintf( Name,"Slowo %s",(char *)Files[i_File] );
    Name[strlen(Name)-4]=0 ;
    F.setCaption( Name );

    return a.exec();
}
