/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/

# include <qapplication.h>
# include <qwidget.h>
# include <qframe.h>
# include <qscrollbar.h>
# include <qsplitter.h>
# include <qlistbox.h>
# include <qlineedit.h>
# include <qmultilinedit.h>
# include <qmenubar.h>
# include <qpopupmenu.h>
# include <qpushbutton.h>
# include <qkeycode.h>
# include <qmessagebox.h>
# include <qcombobox.h>

# include <fontsele.h>

# include <stdlib.h>
# include <stdio.h>

# define min(a,b) (((a)<(b)) ? (a) : (b))
# define max(a,b) (((a)>(b)) ? (a) : (b))

// ------------------------------------------------------------------------
class t_ListBox : public QListBox
{  Q_OBJECT

//protected:

public:
   void keyPressEvent( QKeyEvent *E );
   t_ListBox( QWidget *parent=0, const char *name=0 );
};
// ------------------------------------------------------------------------
class t_LineEdit : public QLineEdit
{
//protected:

public:
   void keyPressEvent( QKeyEvent *E );
   t_LineEdit( QWidget *parent=0, const char *name=0 );
};
// ------------------------------------------------------------------------
class t_Widget : public QWidget
{
    Q_OBJECT
public:
    t_ListBox  *List ;
    QScrollBar *SB ;
    t_LineEdit *Text ;
    long       n_Line ;

    void resizeEvent( QResizeEvent *E );
    void redraw( void );
private slots:
    void selected1( int i );
    void sb_change( int i );
public slots:
    void text_change( const char *text );
public:
    t_Widget( QWidget *parent=0, const char *name=0 );
};
// ------------------------------------------------------------------------
class t_Widget2 : public QWidget
{
    Q_OBJECT
public:
    QLineEdit      *Trans ;
    QMultiLineEdit *Text1 ;

    void resizeEvent( QResizeEvent *E );
    //void redraw( void );
private slots:
    //void selected1( int i );
    //void sb_change( int i );
    //void text_change( const char *text );
public:
    t_Widget2( QWidget *parent=0, const char *name=0 );
};
// ------------------------------------------------------------------------
class t_Help : public QWidget
{
   Q_OBJECT

   QMultiLineEdit *Text ;
   QPushButton    *Button ;

public:
   t_Help( QWidget *parent=0, const char *name=0 );
   void  resizeEvent( QResizeEvent *E );
private slots:
   void  close1( void );
};
// ------------------------------------------------------------------------
struct t_TextStande
{  char color ;     // 
   char Font[99] ;  //  
};
struct t_DictStande
{  t_TextStande Text[5] ;
   char  Divider[10] ; // 
   char  SortOrder ;   //  0 - - 1 - -
   char  fTrans ;      //   
};

struct t_Stande1
{
   char          Path[200] ;
   char          Geometry[20] ;
   t_DictStande *Dict ;
   short         i_default_Dict ;
   short         n_Dict ;
   void          init( void );
   char          read1( void );
   void          read2( void );
   void          write( void );
};
// ------------------------------------------------------------------------
class t_Stande : public QWidget
{
   Q_OBJECT

   QPixmap     *Pix ;
   QComboBox   *Dict ;
   QListBox    *List ;
   QGroupBox   *Group ;
   QPushButton *Help,*Cancel,*Ok ;
   QPushButton *BFont ;
   QCheckBox   *Trans ;
   QLineEdit   *Divider,*Font ;
   QLabel      *LDict,*LList,*LTrans,*LDivider,*LFont ;
   FontSelect  *fs ;
   char         fsUp ;
   short        x_color,y_color ;
   short        i_Dict,i_List ;
   
   t_DictStande my_Stande ;

public:
    t_Stande( QWidget *parent=0, const char *name=0 );

    void paintEvent( QPaintEvent * );
    void resizeEvent( QResizeEvent *E );
    void mousePressEvent( QMouseEvent *Event );
public slots:
    void selectFont( void );
    void doDictSelect( int i );
    void doListSelect( int i );
    void doOk( void );
    void doCancel( void );
    void setFont( const QFont &_Font );
    void setColor( char _Color );
//    void init( void );
//    void resizeEvent( QResizeEvent *E );
};
// ------------------------------------------------------------------------

class t_Forever : public QWidget
{
    Q_OBJECT
public:
    QSplitter  *Sp ;
    t_Widget   *WW ;
    //QMultiLineEdit *Text1 ;
    t_Widget2  *WW2 ;
    QMenuBar   *Menu ;
    QPopupMenu *Menu1,*Menu2,*Menu3 ;

    t_Forever( QWidget *parent=0, const char *name=0 );
    void init( void );
    void resizeEvent( QResizeEvent *E );
    void set_param( void );
public slots:
    void my_slowar(int i);
    void antwort( void );
    void about( );
    void help( );
    void font( );
    void save_param( );
};
// ------------------------------------------------------------------------
extern char        StartPath[] ;
extern t_Stande   *Stande ;
extern t_Stande1   Stande1 ;
extern t_Forever  *Forever ;

int     load_rcfile( char* rcfile_name, char* cgi_type );
char*   get_value( char* name );
