/***************************************************************************/
/*                ⥪ 直  ࠧ⥩                     */
/*  ᨬ ..                                     28  1996 .   */
/***************************************************************************/
# include <stdarg.h>
# include "mylib.hpp"


/***************************************************************************/
/*                    㭪樨  ࠡ  ப                       */
/***************************************************************************/

/* ----------------------------------------------------------------------- */
# define NOTHING       0x00
# define CHAR          0x01
# define STRING        0x02
# define POINT         0x03
# define INT           0x04
# define FLOAT         0x05

# define BYTE          0x00
# define SHORT         0x10
# define LONG          0x20
# define LONG_DOUBLE   0x30

static short  get_format( char *format, char &Antwort );

/***************************************************************************/
t_String :: t_String( void )
{
   j=0 ; n=1 ;
   s=(char *)Calloc(1,1) ;
}
/***************************************************************************/
t_String :: t_String( char *c )
{
   j=strlen( c );
   n=j+1 ;
   s=(char *)Calloc( n,1 ) ;
   strcpy( s,c );
}
/***************************************************************************/
t_String :: ~t_String( void )
{
   if( s!=NULL ) {  free(s); s=NULL;  }
   j=n=0 ;
}
/***************************************************************************/
void t_String :: operator=( t_String &That )
{
   if( this==&That ) return ;
   j=That.j ;
   n=j+1 ;
   free(s);
   s=(char *)Calloc(n,1);
   strcpy( s,That.s );
}
/***************************************************************************/
void t_String :: operator=( char *c )
{
   j=strlen(c) ;
   n=j+1 ;
   if( s!=NULL ) free(s);
   s=(char *)Calloc(n,1);
   strcpy( s,c );
}
/***************************************************************************/
t_String :: operator char*( void )
{
   return this->s ;
}
/***************************************************************************/
void t_String :: setlen( long N )
{
   if( N<=n ) return ;
   s=(char *)Realloc( s,N );
   n=N ;
}
/***************************************************************************/
void t_String :: operator+=( char c )
{
   if( n<j+2 ) { n=j+2 ; s=(char *)Realloc( s,n );  }
   s[j++]=c ; s[j]=0 ;
}
/***************************************************************************/
void t_String :: operator+=( char *s1 )
{  short n1 ;
   n1=j+strlen(s1);
   if( n1>=n ){ n=n1+1 ; s=(char *)Realloc( s,n );  }
   strcat( s,s1 );
   j=n1 ;
}
/***************************************************************************/
void t_String :: operator+=( t_String &A )
{  short n1 ;
   n1=j+A.j ;
   if( n1>=n ){ n=n1+1 ; s=(char *)Realloc( s,n );  }
   strcat( s,A.s );
   j=n1 ;
}
/***************************************************************************/
t_String  operator+( t_String &B, char c )
{  t_String Dst ;

   Dst.j=B.j+1 ;
   Dst.n=Dst.j+1 ;
   free( Dst.s );
   Dst.s=(char *)Calloc(Dst.n,1);
   strcpy( Dst.s,B.s );
   Dst.s[Dst.j-1]=c ;
   return Dst.s;
}
/***************************************************************************/
t_String  operator+( char c,t_String &B )
{  t_String Dst ;

   Dst.j=B.j+1 ;
   Dst.n=Dst.j+1 ;
   free( Dst.s );
   Dst.s=(char *)Calloc(Dst.n,1);
   Dst.s[0]=c ;
   strcat( Dst.s,B.s );
   return Dst.s ;
}
/***************************************************************************/
t_String  operator+( t_String &B, char *s )
{  t_String Dst ;

   Dst.j=B.j+strlen(s) ;
   Dst.n=Dst.j+1 ;
   free( Dst.s );
   Dst.s=(char *)Calloc( Dst.n,1 );
   strcpy( Dst.s,B.s );
   strcat( Dst.s,s );
   return Dst.s;
}
/***************************************************************************/
t_String  operator+( char *s, t_String &B )
{  t_String Dst ;

   Dst.j=B.j+strlen(s) ;
   Dst.n=Dst.j+1 ;
   free( Dst.s );
   Dst.s=(char *)Calloc( Dst.n,1 );
   strcpy( Dst.s,s );
   strcat( Dst.s,B.s );
   return Dst.s ;
}
/***************************************************************************/
t_String  operator+( t_String &a, t_String &b )
{  t_String Dst ;

   Dst.j=a.j+b.j ;
   Dst.n=Dst.j+1 ;
   free( Dst.s );
   Dst.s=(char *)calloc( Dst.n,1 );
   strcpy( Dst.s,a.s );
   strcat( Dst.s,b.s );
   return Dst.s ;
}
/***************************************************************************/
int  operator==( t_String &A, t_String &B )
{  return !strcmp( A.s,B.s );  }
/***************************************************************************/
int  operator!=( t_String &A, t_String &B )
{  return  strcmp( A.s,B.s );  }
/***************************************************************************/
int  operator> ( t_String &A, t_String &B )
{  return( 0>strcmp( A.s,B.s ) );  }
/***************************************************************************/
int  operator< ( t_String &A, t_String &B )
{  return( 0<strcmp( A.s,B.s ) );  }
/***************************************************************************/
void t_String :: radd( char c, short n1 )
{  short i,n2 ;
   n2=j+n1+1 ;
   if( n2>n ) s=(char *)Realloc( s,n2 );
   for( i=0 ; i<n1 ; i++ )
      s[j++]=c ;
   s[j]=0 ;
}
/***************************************************************************/
void t_String :: mysprintf( char *format,... )
{  long     i,plus ;
   char     F ;
   t_String B ;
   char     format1[10] ;
   char     str1[100],*stmp ;
   va_list  ap;

   va_start( ap,format );

   for( i=0 ; ; i++ )
   {  if( format[i]==0 ) break ;
      if( format[i]=='%' )
      {  plus=get_format( format+i,F );
	 strncpy( format1,format+i,plus );
	 format1[plus]=0 ;
	 switch( F&0x07 )
	 {  case CHAR   : sprintf( str1,format1,va_arg( ap,int )); break ;
	    case STRING : stmp=va_arg( ap,char *);  B+=stmp ;  goto M1 ;
	    case POINT  : sprintf( str1,format1,va_arg( ap,char *)); break ;
	    case INT    :
		 if( (F&0x70)==LONG )
			 { sprintf( str1,format1,va_arg( ap,long  )); break ;}
		    else { sprintf( str1,format1,va_arg( ap,int )); break ;}
	    case FLOAT  :
		 if( (F&0x70)==SHORT )
		 {  sprintf( str1,format1,va_arg( ap,double )); break ;  }
		 if( (F&0x70)==LONG )
		 {  sprintf( str1,format1,va_arg( ap,double)); break ;  }
		 if( (F&0x70)==LONG_DOUBLE )
		 {  sprintf( str1,format1,va_arg( ap,long double)); break ;  }
	    case NOTHING: break ;
	 }
	 B+=str1 ;
M1:      i+=plus-1 ;
      }
      else
	 B+=format[i] ;
   }
   va_end( ap );
   *this=B ;
}
/***************************************************************************/
short  get_format( char *format, char &Antwort )
{  long i ;
   char c,Type,Modif ;

   Type=NOTHING ; Modif=SHORT ;
   for( i=0 ; ; i++ )
   {  c=format[i] ;
      if( c=='l' ) Modif=LONG ;
      if( c=='L' ) Modif=LONG_DOUBLE ;
      if( c==0 ) break ;
      if( c=='c' ){  Type=CHAR ;   break ;  }
      if( c=='s' ){  Type=STRING ; break ;  }
      if( c=='p' ){  Type=POINT ;  break ;  }
      if( c=='d' || c=='i' || c=='o' || c=='u' || c=='x' )
      {  Type=INT ;   break ;  }
      if( c=='f' || c=='e' || c=='g' || c=='E' || c=='G' )
      {  Type=FLOAT ; break ;  }
   }
   Antwort=Modif|Type ;
   if( Type==NOTHING ) return 0 ;
   return i+1 ;
}
/***************************************************************************/
/*                      㭪樨 ࠡ                          */
/***************************************************************************/
void *Malloc( long N )
{  void *v ;
   v=malloc( N );
   if( N<0 ) throw( (char)Err_Internal );
   if( v==NULL && N>0 )
   {  printf("\n Error mallok %ld",N );      
      throw( (char)Err_Memory );
   }
   return v ;
}
/***************************************************************************/
void *Calloc( long N,long S )
{  void *v ;
   v=calloc( N,S );
   if( N*S<0 ) throw( (char)Err_Internal );
   if( v==NULL && N*S>0 )
   {  printf("\n Error kallok %ld %ld",N,S );
      throw( (char)Err_Memory );
   }
   return v ;
}
/***************************************************************************/
void *Realloc( void *v,long L )
{  void *v1 ;
   v1=realloc( v,L );
   if( L<0 ) throw( (char)Err_Internal );
   if( v1==NULL && L>0 )
   {  printf("\n Error reallok %ld",L );
      throw( (char)Err_Memory );
   }
   return v1 ;
}
/***************************************************************************
void Free( void **v )
{  if( *v!=NULL )
   {  free(*v); *v=NULL ;  }
}
/***************************************************************************/
FILE *Fopen( char *Name, char *Schalter )
{  FILE *fr ;
   fr=fopen( Name, Schalter);
   if( fr==NULL ) throw( (char)Err_Fopen );
   return fr ;
}
/***************************************************************************/
void  Fread( void *v, size_t s, size_t n, FILE *fr )
{  long k ;
   k=fread( v, s, n, fr );
   if( k!=n && s*n>0 ) throw( (char)Err_Fread );
}
/***************************************************************************/
void  Fread1( void **v, size_t s, size_t n, FILE *fr )
{  long k ;
   *v=Calloc( s,n );
   k=fread( *v, s, n, fr );
   if( k!=n && s*n>0 ) throw( (char)Err_Fread );
}
/***************************************************************************/
void  Fwrite( void *v, size_t s, size_t n, FILE *fw )
{  long k ;
   k=fwrite( v, s, n, fw );
   if( k!=n && s*n>0 ) throw( (char)Err_Fwrite );
}
/***************************************************************************/
long   FileLength( FILE *fw )
{
   long Cur,L ;

   if( 0!=fgetpos( fw,(fpos_t*)&Cur ) ) throw( -1 );
   if( 0!=fseek( fw,0L,SEEK_END) ) throw( -1 );
   if( 0!=fgetpos( fw,(fpos_t*)&L ) ) throw( -1 );
   if( 0!=fseek( fw,Cur,SEEK_SET) ) throw( -1 );
   return L ;
}
/***************************************************************************/
/*                     㭪樨  ࠡ  䠩                        */
/***************************************************************************/
t_File ::  t_File( void )
{  Name=NULL ;
   File=NULL ;
}
/***************************************************************************/
t_File :: ~t_File( void )
{  if( Name!=NULL ) free(Name);
   if( File!=NULL ) fclose(File);
}
/***************************************************************************/
void t_File :: Fopen( char *Name1, char *Schalter )
{
   File=fopen( Name1,Schalter );
   if( File==NULL )
   {
      throw( (char)Err_Fopen );
   }
   Name=(char *)Calloc( strlen(Name1)+1,1 );
   strcpy( Name,Name1 );
}
/***************************************************************************/
void t_File :: Fwrite( void *v, size_t s, size_t n )
{  long n1 ;

   n1=fwrite( v,s,n,File );
   if( n1!=n )
      throw( (char)Err_Fwrite );
}
/***************************************************************************/
void t_File :: Fread( void *v, size_t s, size_t n )
{  long n1 ;

   n1=fread( v,s,n,File );
   if( n1!=n )
       throw( (char)Err_Fread );
}
/***************************************************************************/
void t_File :: Fseek( long Pos, int Mode )
{  int r ;

   r=fseek( File,Pos,Mode );
   if( r!=0 )
       throw( (char)Err_Fseek );
}
