/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
****************************************************************************/
# include <stdio.h>
# include <malloc.h>
# include <stdlib.h>

# include "define.h"
# include "s_defkey.h"
# include "schone2.h"

# define max(a,b)    (((a) > (b)) ? (a) : (b))
# define min(a,b)    (((a) < (b)) ? (a) : (b))

static short Shift=0 ;

class t_Save_Screen              //    
{
   uchar  *stek ;
   short   l_stek ;
   short   j_stek ;
public:
   t_Save_Screen( short l );
   ~t_Save_Screen( void );
   void   save   ( short y1, short x1, short y2, short x2 );
   void   save_rame( short y1, short x1, short y2, short x2 );
   void   restore( void );
} ;

static uchar         *Schirm ;   //   (+)
static char           n_Line1 ;
static t_Save_Screen  Save(4000) ;

/***************************************************************************/
void x_begin_schone(int argc, char **argv);

void s_begin_schone( void )
{  char *argv[1] ;
   argv[0]="Dictionary" ;
   x_begin_schone( 1, argv );
   Schirm=(uchar *)calloc( 4000,1 ) ;
}

void s_begin_schone( int argc, char **argv )
{
   x_begin_schone( argc, argv );
   Schirm=(uchar *)calloc( 4000,1 ) ;
}
/* ----------------------------------------------------------------------- */
uchar  *s_schirm( void ) { return Schirm ; }
/* ----------------------------------------------------------------------- */
void s_rame1_f( short y1, short x1, short y2, short x2, uchar f )
{  short i,r ;

   for( i=x1+1 ; i<x2 ; i++ )
   {  r=(80*y1+i)<<1 ; Schirm[ r ]='-' ; Schirm[ r+1 ]=f ;
      r=(80*y2+i)<<1 ; Schirm[ r ]='-' ; Schirm[ r+1 ]=f ;
   }
   for( i=y1+1 ; i<y2 ; i++ )
   {  r=(80*i+x1)<<1 ; Schirm[ r ]='|' ; Schirm[ r+1 ]=f ;
      r=(80*i+x2)<<1 ; Schirm[ r ]='|' ; Schirm[ r+1 ]=f ;
   }
   r=(80*y1+x1)<<1 ; Schirm[ r ]='+' ; Schirm[ r+1 ]=f ;
   r=(80*y2+x1)<<1 ; Schirm[ r ]='+' ; Schirm[ r+1 ]=f ;
   r=(80*y1+x2)<<1 ; Schirm[ r ]='+' ; Schirm[ r+1 ]=f ;
   r=(80*y2+x2)<<1 ; Schirm[ r ]='+' ; Schirm[ r+1 ]=f ;
}
/* ----------------------------------------------------------------------- */
void s_rame1_F( short y1, short x1, short y2, short x2, uchar f )
{  short i,j,r1 ;

   s_rame1_f( y1, x1, y2, x2, f );
   for( j=y1+1 ; j<y2 ; j++ )
   {  for( i=x1+1 ; i<x2 ; i++ )
      {   r1=(80*j+i)<<1 ;
	  Schirm[ r1 ]=' ' ;
	  Schirm[ r1+1 ]=f ;
      }
   }
}
/* ----------------------------------------------------------------------- */
void s_rame2_f( short y1, short x1, short y2, short x2, uchar f )
{  short i,r ;

   for( i=x1+1 ; i<x2 ; i++ )
   {  r=(80*y1+i)<<1 ; Schirm[ r ]='=' ; Schirm[ r+1 ]=f ;
      r=(80*y2+i)<<1 ; Schirm[ r ]='=' ; Schirm[ r+1 ]=f ;
   }
   for( i=y1+1 ; i<y2 ; i++ )
   {  r=(80*i+x1)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
      r=(80*i+x2)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
   }
   r=(80*y1+x1)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
   r=(80*y2+x1)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
   r=(80*y1+x2)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
   r=(80*y2+x2)<<1 ; Schirm[ r ]='#' ; Schirm[ r+1 ]=f ;
}
/* ----------------------------------------------------------------------- */
void s_rame2_F( short y1, short x1, short y2, short x2, uchar f )
{  short i,j,r1 ;

   s_rame2_f( y1, x1, y2, x2, f );
   for( j=y1+1 ; j<y2 ; j++ )
   {  for( i=x1+1 ; i<x2 ; i++ )
      {   r1=(80*j+i)<<1 ;
	  Schirm[ r1 ]=' ' ;
	  Schirm[ r1+1 ]=f ;
      }
   }
}
/* ----------------------------------------------------------------------- */
void s_text_yxf( short y, short x, uchar f, char *str )
{  short i,r1 ;

   r1=80*y+x ;
   for( i=0 ; str[i]!=0 ; i++ )
   {  Schirm[ (r1+i)<<1 ]=str[i] ;
      Schirm[ ((r1+i)<<1)+1 ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void s_text_yxfl( short y, short x, uchar f, short L, char *str )
{  short i,r1 ;

   r1=80*y+x ;
   for( i=0 ; str[i]!=0 && i<L ; i++ )
   {  Schirm[ (r1+i)<<1 ]=str[i] ;
      Schirm[ ((r1+i)<<1)+1 ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void s_text_yx( short y,short x,char *str )
{  short i,r1 ;
   uchar f ;

   r1=80*y+x ;
   for( i=0 ; str[i]!=0 ; i++ )
      Schirm[ (r1+i)<<1 ]=str[i] ;
}
/* ----------------------------------------------------------------------- */
void s_farbe_yxt( short y, short x, uchar *t, char *str )
{  short i,r1,r2,f ;
   uchar c ;

   r1=80*y+x ;
   for( i=0 ; str[i]!=0 ; i++ )
   {  f=0x07 ; r2=str[i] ;
      if( '0'<=r2 && r2<= '9' ) f=t[r2-'0'] ;
      if( 'a'<=r2 && r2<= 'z' ) f=t[r2-'a'+10] ;
      Schirm[ ((r1+i)<<1)+1 ]=f ;
   }
}
/* ----------------------------------------------------------------------- */
void s_text_yxf1( short y, short x, uchar f, char *str )
{  short i,r ;

   r = (80*y+x)<<1 ;
   Schirm[ r ] = '\"' ; Schirm[ r+1 ] = f ;
   for( i=0 ; str[i]!=0 ; i++ )
   {  r=(80*y+x+i+1)<<1 ;
      Schirm[ r ] = str[i] ; Schirm[ r+1 ] = f ;
   }
   r=r+2 ;
   Schirm[ r ] = '\"' ; Schirm[ r+1 ] = f ;
}
/* ----------------------------------------------------------------------- */
void s_nacht( void )
{  short i ;

   for( i=0 ; i<25*80 ; i++ )
   {   Schirm[ i<<1 ]=' ' ; Schirm[ (i<<1)+1 ]=0 ;   }
}
/* ----------------------------------------------------------------------- */
t_Save_Screen :: t_Save_Screen( short L )
{
   stek=(uchar *)calloc( L,1 );
   if( stek==NULL ) throw( -1 );
   j_stek=0 ;
   l_stek=L ;
}
/* ----------------------------------------------------------------------- */
t_Save_Screen :: ~t_Save_Screen( void )
{
   if( stek!=NULL ){  free( stek ); stek=NULL ;  }
   j_stek=0 ;
   l_stek=0 ;
}
/* ----------------------------------------------------------------------- */
void s_save_rame( short s1, short p1, short s2, short p2 )
{  Save.save_rame( s1, p1, s2, p2 );  }

void s_save( short s1, short p1, short s2, short p2 )
{  Save.save( s1, p1, s2, p2 );  }

void s_restore( void )
{  Save.restore( );  }
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: save( short y1, short x1, short y2, short x2 )
{  short i,j,r ;

   for( i=y1 ; i<=y2 ; i++ )
   {  for( j=x1 ; j<=x2 ; j++ )
      {   r=(80*i+j)<<1 ;
	  stek[j_stek++] = Schirm[ r+1 ] ;
	  stek[j_stek++] = Schirm[ r ] ;
      }
   }
   stek[j_stek++]=(uchar )x1 ; stek[j_stek++]=(uchar )y1 ;
   stek[j_stek++]=(uchar )x2 ; stek[j_stek++]=(uchar )y2 ;
   stek[j_stek++]=0 ;
}
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: save_rame( short s1, short p1, short s2, short p2 )
{  short i,r,r1,r2 ;

   r1=80*s1 ; r2=80*s2 ;
   for( i=p1 ; i<=p2 ; i++ )
   {  r=(r1+i)<<1 ;
      stek[j_stek++]=Schirm[ r ] ;
      stek[j_stek++]=Schirm[ r+1 ] ;
      r=(r2+i)<<1 ;
      stek[j_stek++]=Schirm[ r ] ;
      stek[j_stek++]=Schirm[ r+1 ] ;
   }
   for( i=s1 ; i<=s2 ; i++ )
   {  r1=(80*i+p1)<<1 ;
      stek[j_stek++]=Schirm[ r1 ] ;
      stek[j_stek++]=Schirm[ r1+1 ] ;
      r2=(80*i+p2)<<1 ;
      stek[j_stek++]=Schirm[ r2 ] ;
      stek[j_stek++]=Schirm[ r2+1 ] ;
   }
   stek[j_stek++]=(uchar )p1 ; stek[j_stek++]=(uchar )s1 ;
   stek[j_stek++]=(uchar )p2 ; stek[j_stek++]=(uchar )s2 ;
   stek[j_stek++]=1 ;
}
/* ----------------------------------------------------------------------- */
void t_Save_Screen :: restore( void )
{  short i,j,p1,p2,s1,s2,
	 r,r1,r2 ;
   uchar c,f ;

   f =stek[--j_stek] ;
   s2=stek[--j_stek] ; p2=stek[--j_stek] ;
   s1=stek[--j_stek] ; p1=stek[--j_stek] ;
   if( f==1 )
   {  for( i=s2 ; s1<=i ; i-- )
      {  r=(80*i+p2)<<1 ;
	 f=Schirm[ r+1 ] = stek[--j_stek] ;
	 c=Schirm[ r ]   = stek[--j_stek] ;
	 r=(80*i+p1)<<1 ;
	 f=Schirm[ r+1 ] = stek[--j_stek] ;
	 c=Schirm[ r ]   = stek[--j_stek] ;
      }
      r1=80*s1 ; r2=80*s2 ;
      for( i=p2 ; p1<=i ; i-- )
      {  r=(r2+i)<<1 ;
	 f=Schirm[ r+1 ] = stek[--j_stek] ;
	 c=Schirm[ r ]   = stek[--j_stek] ;
	 r=(r1+i)<<1 ;
	 f=Schirm[ r+1 ] = stek[--j_stek] ;
	 c=Schirm[ r ]   = stek[--j_stek] ;
      }
   }
   else
   {  for( i=s2 ; s1<=i ; i-- )
	 for( j=p2 ; p1<=j ; j-- )
	 {   r=(80*i+j)<<1 ;
	     c=Schirm[ r ]   = stek[--j_stek] ;
	     f=Schirm[ r+1 ] = stek[--j_stek] ;
	 }
   }
}
/* ----------------------------------------------------------------------- */
short s_clear_cursor( )
//{  return s_set_cursor1( 0 );  }
{  return 0 ;  }
/* ----------------------------------------------------------------------- */
int s_tst_event( void )
{  return 0 ;  }
/* ----------------------------------------------------------------------- */


